//
//  Char.swift
//  TowerDefense
//
//  Created by 杉本裕樹 on 2016/03/13.
//  Copyright © 2016年 MyName. All rights reserved.
//

import UIKit
import SpriteKit
import GameplayKit

class Char: SKSpriteNode {
    lazy var stateMachine: GKStateMachine = {
        let stateMachine = GKStateMachine(states: [
            AttackState(char: self),
            StayState(char: self)
            ])
        stateMachine.enterState(AttackState)
        return stateMachine
    }()
    
    class CharState: GKState {
        weak var char: Char?
        var power: Int {
            return char?.power ?? 0
        }
        
        init(char: Char?) {
            self.char = char
        }
        
        func enableToAttack() -> Bool {
            return false
        }
    }
    
    class AttackState: CharState {
        override func enableToAttack() -> Bool {
            return true
        }
    }
    
    class AngryState: CharState {
        var enteredDate = NSDate()
        override var power: Int {
            return char?.power ?? 0
        }
        
        override func enableToAttack() -> Bool {
            return true
        }
        
        override func didEnterWithPreviousState(previousState: GKState?) {
            enteredDate = NSDate()
        }
        
        override func updateWithDeltaTime(seconds: NSTimeInterval) {
            if NSDate().timeIntervalSinceDate(enteredDate) > 10 {
                char?.stateMachine.enterState(AttackState)
            }
        }
    }
    
    class StayState: CharState {
        var enteredDate = NSDate()
        override func didEnterWithPreviousState(previousState: GKState?) {
            enteredDate = NSDate()
        }
        
        override func updateWithDeltaTime(seconds: NSTimeInterval) {
            if NSDate().timeIntervalSinceDate(enteredDate) > 0.2 {
                char?.stateMachine.enterState(AttackState)
            }
        }
        
        override func enableToAttack() -> Bool {
            return false
        }
    }
    var power = 1
}
